//------------------------------------------------------------------
//
//
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  LimeGreen

extern int  period          = 15;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

double cfhd[];
double cfhu[];
double cfl[];
double trend[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,cfhd); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,cfhu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,cfl);
   SetIndexBuffer(3,trend);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      double N=0,M=0;
   	for (int cnt=period; cnt>=1; cnt--)
      { 
         N += cnt*cnt;
         M += cnt;
      }
      for(int i = limit; i >= 0; i--)
      {
         double ZYVar         = 0;
         double TYVar         = 0;
         double ZIndicatorVar = 0;
         double TIndicatorVar = 0;
         for (int k=period; k>0; k--) 
         {
            double tmp = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN ,i+k-1);
                        ZYVar += tmp*(period-k+1);
                        TYVar += tmp;
                   tmp = iMA(NULL,0,5,0,MODE_SMMA,PRICE_MEDIAN,i+k+2);
                        ZIndicatorVar += tmp*(period-k+1);
                        TIndicatorVar += tmp;
         }
         double AY         = (TYVar        +(N-2*ZYVar        )*period/M)/M;
         double AIndicator = (TIndicatorVar+(N-2*ZIndicatorVar)*period/M)/M;
      	if (StringFind(Symbol(),"JPY",0)>=2)
      	     cfl[i]   = ( 1000)*MathLog(AY/AIndicator);
      	else cfl[i]   = (-1000)*MathLog(AY/AIndicator);
      	     cfhu[i]  = EMPTY_VALUE;
      	     cfhd[i]  = EMPTY_VALUE;
      	     trend[i] = trend[i+1];
      	     if (cfl[i] > 0) { cfhu[i]= High[i]; cfhd[i]= Low[i]; trend[i] =  1; }
      	     if (cfl[i] < 0) { cfhd[i]= High[i]; cfhu[i]= Low[i]; trend[i] = -1; }
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(" up");
         if (trend[whichBar] == -1) doAlert(" down");
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(TimeToStr(TimeLocal(),TIME_SECONDS)," CoefOfLine bars trend changed to "+doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"CoefOfLine bars"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}